#include "cpl_conv.h"
#include "cpl_multiproc.h"
#include "gdal.h"

extern void set_time_1(double dfDelay);
extern void set_time_2(double dfDelay);

void thread_func(void* unused)
{
    set_time_1(0.6);
    set_time_2(0);
    printf("begin thread\n");
    GDALFlushCacheBlock();
    printf("end of thread\n\n");
}

int main(int argc, char* argv[])
{
    CPLSetConfigOption("GDAL_CACHEMAX", "0");
    GDALAllRegister();
    GDALDatasetH hDS = GDALOpen("byte.tif", GA_ReadOnly);
    char buf[20*20];
    set_time_1(0);
    set_time_2(0);
    printf("cache fill\n");
    GDALRasterIO(GDALGetRasterBand(hDS, 1), GF_Read, 0, 0, 20, 20, buf, 20, 20, GDT_Byte, 0, 0);
    printf("end of cache fill\n");
    printf("buf[0]=%d\n\n", (int)buf[0]);
    
    CPLCreateThread(thread_func, NULL);
    CPLSleep(0.5);
    set_time_2(0.3);
    
    printf("re read block\n");
    GDALRasterIO(GDALGetRasterBand(hDS, 1), GF_Read, 0, 0, 20, 20, buf, 20, 20, GDT_Byte, 0, 0);
    printf("end of re read block\n");
    
    printf("buf[0]=%d\n", (int)buf[0]);
    
    while(1);
    
    return 0;
}
